###############################################################################
#                                                                             #
# PicasaGallery.pm  by XTC                                                    #
#                                                                             #
###############################################################################
#                                                                             #
# Version:        Beta 1				                      #
# Date:           09 / 2014                                                   #
# Distributed by: http://www.yabbserver.com                                   #
#                                                                             #
# =========================================================================== #
#                                                                             #
# NOTE: Picasa is a registered trademark of Google Inc.                       #
#       The author declines every responsability about this software          #
#                                                                             #
# =========================================================================== #
#                                                                             #
# Copyright (c) 2014 YaBB Server (www.yabbserver.com) - All Rights Reserved.  #
#       The author declines every responsability about this software          #
#                                                                             #
###############################################################################

$picasagallerypmver = 'Picassa Gallery Beta 1';
if ( $action eq 'detailedversion' ) { return 1; }

LoadLanguage("PicasaGallery");

#<----------------------------------------------->#
# MAIN PROGRAM
#<----------------------------------------------->#

use LWP::Simple;

if ( $INFO{'picasaid'} || $FORM{'picasaid'} ) {
	$picasaid = $INFO{'picasaid'} || $FORM{'picasaid'}; 
}

$pic_gallery = qq~<a href="$scripturl?picasaid=$picasaid" title="$gallery{'2'}"><img src="$yyhtml_root/PicasaGallery/picasa.png" alt="" /></a>~;
$picasaurlimg = qq~<img src="$yyhtml_root/PicasaGallery/picasaurl.png" alt="" />~;
$galleriaimg = qq~<img src="$yyhtml_root/PicasaGallery/galleria.png" alt="" />~;
$flashimg = qq~<img src="$yyhtml_root/PicasaGallery/flash.png" alt="" />~;
$photoindeximg = qq~<img src="$yyhtml_root/PicasaGallery/photoindex.png" alt="" />~;
$photolinkimg = qq~<img src="$yyhtml_root/PicasaGallery/photolink.png" alt="" />~;
$photoimg = qq~<img src="$yyhtml_root/PicasaGallery/photo.png" alt="" />~;
$infoimg = qq~<img src="$yyhtml_root/PicasaGallery/info.png" alt="" />~;

$yyinlinestyle .= qq~
<link href="$yyhtml_root/PicasaGallery/gallery.css" rel="stylesheet" type="text/css" />
<script language="JavaScript" type="text/javascript">
    <!--
	function picasadirect(seite){
		window.open(seite,"_blank");
	}
    //-->
</script> 
~;

#<----------------------------------------------->#
# Gallery access check
#<----------------------------------------------->#

	if (!$picasagroups) { fatal_error( q{}, "$gallery{'27'}" ); }
	if ($iamguest && $picasagroups > 1) { fatal_error('no_access'); }
	if ($picasagroups  == 3 && !$iamadmin && !$iamgmod && !$iammod) { fatal_error('no_access'); }
	if ($picasagroups  == 4 && !$iamadmin && !$iamgmod) { fatal_error('no_access');; }
	my $access_to_gallery = 0;
	if ($iamadmin) { $access_to_gallery = 1; }
	elsif ( $picasamemgroups eq q{} ) { $access_to_gallery = 1; }
	elsif ( $iamguest && $picasamemgroups ) { $access_to_gallery = 0; }
	else {
		foreach my $gall_gr (split(/, /, $picasamemgroups)) {
			if ($gall_gr eq ${$uid.$username}{'position'}) { $access_to_gallery = 1; last; }
			foreach (split(/,/, ${$uid.$username}{'addgroups'})) {
				if ($gall_gr eq $_) { $access_to_gallery = 1; last; }
			}
		}
	}
	if (!$access_to_gallery) { fatal_error('no_access'); }

#<----------------------------------------------->#
# Gallery Overview
#<----------------------------------------------->#

sub PicasaGallery {

$thumb_box_width = ($thumb_alb_size + 10) ."px";
if ( $thumb_alb_c_u eq 'c' ) { $thumb_box_width = $thumb_alb_size . "px"; }

my $alb_display = 'display:inline';
        if ( $ENV{'HTTP_USER_AGENT'} =~ /opera/ism ) {
            $alb_display = 'display:inline-block';
        }
        elsif ( $ENV{'HTTP_USER_AGENT'} =~ /firefox/ism ) {
            $alb_display = 'display:inline-block';
}


my $feedurl = "https://picasaweb.google.com/data/feed/base/user/$picasaid?alt=rss&hl=$piclangcode&kind=album&imgmax=1600&thumbsize=$thumb_alb_size$thumb_alb_c_u";
my $picasacontent = get($feedurl);
$picasacontent =~ s/\n/ /g;
$picasacontent =~ s/\r/ /g;
$picasacontent =~ s/\r\n/ /g;

	@totalResults = $picasacontent =~ /<openSearch:totalResults>(.*?)<\/openSearch:totalResults>/g;

$res=0;
while ($res<(1*2)){
	$picasResults .= qq~$totalResults[$res]~;
	$res+=2;
}

$i=0;
$albumzahl=1;
while ($i<$picasResults){

if ( $picasacontent =~ /<item><guid isPermaLink='.*?'>(.*?)<\/guid><pubDate>(.*?)<\/pubDate><atom:updated>.*?<\/atom:updated><category domain='.*?'>.*?<\/category><title>(.*?)<\/title><description>(.*?)<\/description><link>(.*?)<\/link><author>(.*?)<\/author><media:group><media:content url='(.*?)' type='(.*?)' medium='(.*?)'\/><media:credit>(.*?)<\/media:credit>(.*?)<media:keywords.*?<media:thumbnail url='(.*?)' height='(.*?)' width='(.*?)'\/><media:title type='.*?'>(.*?)<\/media:title><\/media:group>/g ) {
	$alb_piclink = $1;
	$alb_pubDate = $2;
	$alb_title = $3;
	$alb_description = $4;
	$alb_link = $5;
	$alb_autor = $6;
	$alb_media_content_url = $7;
	$alb_media_content_type = $8;
	$alb_media_content_medium = $9;
	$alb_media_credit = $10;
	$alb_media_description = $11;
	$alb_media_thumbnail_url = $12;
	$alb_media_thumbnail_height = $13;
	$alb_media_thumbnail_width = $14;
	$alb_media_title = $15;
}
				
$alb_media_thumbnail_height = $alb_media_thumbnail_height ."px";
$alb_media_thumbnail_width = $alb_media_thumbnail_width ."px";

FromHTML($alb_description);

if ( $alb_description =~ /color=".*?">(.*?)<\/font><font color=".*?">(.*?)<\/font><br\/><font color=".*?">(.*?)<\/font><font color=".*?">(.*?)<\/font><br\/><font color=".*?">(.*?)<\/font><font color=".*?">(.*?)<\/font><br\/><p/g ) {
	$location_value = $1;
	$location_photos = $2;
	$date_value = $3;
	$date_upload = $4;
	$number_value = $5;
	$number_photos = $6;
}

if ( $alb_description =~ /color=".*?">(.*?)<\/font><font color=".*?">(.*?)<\/font><br\/><font color=".*?">(.*?)<\/font><font color=".*?">(.*?)<\/font><br\/><p/g ) {
	$date_value = $1;
	$date_upload = $2;
	$number_value = $3;
	$number_photos = $4;
	$location_value = qq~~;
	$location_photos = qq~~;
}

if ( $alb_media_description =~ /<media:description type='.*?'>(.*?)</g ) {
	$media_description = $1;
	$media_description =~ s/"/&quot;/g;
	$alb_media_description = qq~<li><b>$gallery{'3'}</b><br />$media_description</li>~;
}

$alblink = rindex($alb_media_thumbnail_url,"/") + 1;
$alblink1 = substr($alb_media_thumbnail_url,$alblink);
( $albumlink, $alblinkex ) = split /\./xsm, $alblink1;

$albid = rindex($alb_piclink,"/") + 1;
$albid1 = substr($alb_piclink,$albid);
( $album_id, $albidex ) = split /\?/xsm, $albid1;

if ( $alb_link =~ /https:\/\/picasaweb.google.com\/(.*?)\/.*?/g ) {
	$picasa_user_id = $1;
	$picasaid = $picasa_user_id;
}

        $quicklinks = qq~<div style="position:relative;$alb_display">
            <ul id="$album_id" class="QuickLinks" onmouseover="keepLinks('$album_id')" onmouseout="TimeClose('$album_id')">
                <li><b>$alb_title</b></li>
                <li><b>$gallery{'4'}</b> $number_photos</li>
                <li><b>$gallery{'5'}</b> $date_upload</li>
                <li><b>$gallery{'6'}</b> $album_id</li>
                <li><b>$gallery{'7'}</b> $alb_media_credit</li>~;
if ($location_photos) {
        $quicklinks .= qq~
                <li><b>$gallery{'8'}</b> $location_photos</li>~;
}
        $quicklinks .= qq~
		$alb_media_description
        	</ul><a href="javascript:quickLinks('$album_id')">$infoimg</a></div>~;

	$picasacalls .= qq~
		<div class="small" id="hardShade" style="display: inline-block; width: $thumb_box_width; margin: 5px; padding: 10px;  margin-bottom:50px">
                    <b>$alb_title</b> (<i>$number_photos</i>)<br /><br />
		    <form action="$scripturl?action=galleryphoto" method="post">
			<input type="hidden" name="picasaid" value="$picasaid" />
			<input type="hidden" name="album" value="$album_id" />
			<input type="hidden" name="album_ti" value="$alb_title" />
			<input type="hidden" name="media_description" value="$media_description" />
	~;
if ( $thumb_alb_c_u eq 'c' ) {
		$picasacalls .= qq~
			<input type="submit" style="background-image:url($alb_media_thumbnail_url); width:$alb_media_thumbnail_width; height:$alb_media_thumbnail_height; border: 0;" title="$gallery{'9'} '$alb_title' $gallery{'10'}" alt="$gallery{'9'} '$alb_title' $gallery{'10'}" name="submit" value="" />
	~;
} else {
		$picasacalls .= qq~
			<input type="image" style="display: block; margin: 0 auto" src="$alb_media_thumbnail_url" title="$gallery{'9'} '$alb_title' $gallery{'10'}" alt="$gallery{'9'} '$alb_title' $gallery{'10'}" name="submit" value="" />
	~;
}
		$picasacalls .= qq~
                    <br /><br />
                    <div style="float: left;  margin-right: 5px;">
			<input type="submit" style="background-image:url($yyhtml_root/PicasaGallery/photoindex.png); width:16px; height:16px; border:0;" title="$gallery{'9'} '$alb_title' $gallery{'10'}" alt="$gallery{'9'} '$alb_title' $gallery{'10'}" name="submit" value="" />
                    </div>
		    </form>
                    <div style="float: left;">
	~;
if ( $linkgalleria ) {
		$picasacalls .= qq~
		    <form action="$scripturl?action=galleryplugin" method="post">
			<input type="hidden" name="picasaid" value="$picasaid" />
			<input type="hidden" name="album" value="$albumlink" />
			<input type="hidden" name="album_ti" value="$alb_title" />
			<input type="hidden" name="plugin" value="galleria" />
			<input type="hidden" name="photos" value="$number_photos" />
			<input type="hidden" name="media_description" value="$media_description" />
			<input type="submit" style="background-image:url($yyhtml_root/PicasaGallery/galleria.png); width:16px; height:16px; border:0;" title="$gallery{'9'} '$alb_title' $gallery{'11'}" alt="$gallery{'9'} '$alb_title' $gallery{'11'}" name="submit" value="" />
		    </form>
	~;
}
if ( $linkdivviewer ) {
		$picasacalls .= qq~
		    <form action="$scripturl?action=galleryplugin" method="post">
			<input type="hidden" name="picasaid" value="$picasaid" />
			<input type="hidden" name="album" value="$album_id" />
			<input type="hidden" name="album_ti" value="$alb_title" />
			<input type="hidden" name="plugin" value="divviewer" />
			<input type="hidden" name="media_description" value="$media_description" />
			<input type="submit" style="background-image:url($yyhtml_root/PicasaGallery/photo.png); width:16px; height:16px; border:0;" title="$gallery{'9'} '$alb_title' $gallery{'12'}" alt="$gallery{'9'} '$alb_title' $gallery{'12'}" name="submit" value="" />
		    </form>
	~;
}
if ( $linkpicasaflash ) {
		$picasacalls .= qq~
		    <form action="$scripturl?action=galleryplugin" method="post">
			<input type="hidden" name="picasaid" value="$picasaid" />
			<input type="hidden" name="album" value="$album_id" />
			<input type="hidden" name="album_ti" value="$alb_title" />
			<input type="hidden" name="plugin" value="flash" />
			<input type="hidden" name="photos" value="$number_photos" />
			<input type="hidden" name="media_description" value="$media_description" />
			<input type="submit" style="background-image:url($yyhtml_root/PicasaGallery/flash.png); width:16px; height:16px; border:0;" title="$gallery{'9'} '$alb_title' $gallery{'13'}" alt="$gallery{'9'} '$alb_title' $gallery{'13'}" name="submit" value="" />
		    </form>
	~;
}
if ( $linkpicasa ) {
		$picasacalls .= qq~
		    <form>
			<input type="button" style="background-image:url($yyhtml_root/PicasaGallery/picasaurl.png); width:16px; height:16px; border:0;" title="$gallery{'9'} '$alb_title' $gallery{'14'}" alt="$gallery{'9'} '$alb_title' $gallery{'14'}" name="submit" value="" onClick="picasadirect('https://picasaweb.google.com/$picasaid/$albumlink?hl=$piclangcode&noredirect=1')" />
		    </form>
	~;
}
		$picasacalls .= qq~
                    </div>
                    <div style="float: left;  margin-left: 5px;">
                        $quicklinks
                    </div>
		</div>
	~;

	$i++;
	$albumzahl++;
}

if ( -e "$vardir/gallery_header.txt" && $show_gallery_header ) {
    fopen( GALHEADER, "$vardir/gallery_header.txt" ) || fatal_error( 'cannot_open', 'gallery_header.txt', 1 );
        @galleryheader = <GALHEADER>;
    fclose( GALHEADER );

        @gallery_header = join q{}, @galleryheader;
	$gallery_header[0] =~ s/\n/ /g;

	if ( $gallery_header[0] =~ /\[$picasaid\](.*?)\[\/$picasaid\]/g ) { $the_gallery_header = $1; } else { $the_gallery_header = $gallery_header[0]; }
	$gallery_header .= qq~
		<tr>
		 <td class="windowbg2 left">
			$the_gallery_header
		 </td>
		</tr>
	~;
} else {
	$gallery_header .= qq~
		<tr>
		 <td class="nav h_30px">&nbsp;</td>
		</tr>
	~;
	}

	$yymain .= qq~
	<table class="tabtitle pad_3px">
		<tr>
		 <td>$pic_gallery $gallery{'2'}</td>
		</tr>
	</table>
	<table class="bordercolor pad_4px cs_thin" >
		$gallery_header
		<tr>
		 <td class="catbg" style="padding: 8px;">
			<b>$gallery{'17'} ($picasResults)</b>
		 </td>
		</tr>
		<tr>
		 <td class="windowbg2 left">
			$picasacalls
		 </td>
		</tr>
		 
	~;

	$yymain .= qq~
		<tr>
        	 <td class="catbg left" style="padding: 8px;">
	<script>
	function picuploadwin() {
        	window.open("https://docs.google.com/picker?protocol=gadgets&relayUrl=https://picasaweb.google.com/s/v/84.17/rpc_relay.html&hostId=pwa&hl=$piclangcode&rpcService=lhid_picker&rpctoken=1g73kb46x4u9q&selectButtonLabel=Ok&navHidden=true&multiselectEnabled=true&white=true&chromeMode=none&nav=((%22upload%22,null,%7B%22cRename%22:%22pname%22,%22query%22:%22photos%22,%22data%22:%7B%22owner_name%22:%22$picasaid%22,%22disable_asbe_notification%22:%22false%22,%22streamid%22:null%7D%7D))", 'list', 'width=800,height=500, scrollbars=yes');
	}
	</script>
	<a href="javascript:picuploadwin()">$gallery{'15'}</a>	 
                 </td>
		</tr>
	</table>
	~;

	template();
	exit;
}

#<----------------------------------------------->#
# Photo Index
#<----------------------------------------------->#

sub GalleryPhoto {

$useralbum = $FORM{'album'};
$picasaid = $FORM{'picasaid'} || $INFO{'picasaid'};
$useralbumtitle = $FORM{'album_ti'};

if ( $useralbum eq q{} ) {
	$yySetLocation = qq~$scripturl?action=gallery~;
    redirectexit();
}
$media_description = $FORM{'media_description'};

        my $pic_display = 'display:inline';
        if ( $ENV{'HTTP_USER_AGENT'} =~ /opera/ism ) {
            $pic_display = 'display:inline-block';
        }
        elsif ( $ENV{'HTTP_USER_AGENT'} =~ /firefox/ism ) {
            $pic_display = 'display:inline-block';
        }

$thumb_box_width = ($thumb_index_size - 15) ."px";

my $feedurl = "https://picasaweb.google.com/data/feed/base/user/$picasaid/albumid/$useralbum?alt=rss&start-index=1&max-results=1000&hl=$piclangcode&kind=photo&imgmax=1600&thumbsize=$thumb_index_size$thumb_index_c_u";
my $picasacontent = get($feedurl);

	@totalResults = $picasacontent =~ /<openSearch:totalResults>(.*?)<\/openSearch:totalResults>/g;

$res=0;
while ($res<(1*2)){
	$picasResults = qq~$totalResults[$res]~;
	$res+=2;
}
$dvviewer=0;
$i=0;
$albumzahl=1;
$gal_pic_row=1;
while ($i < $picasResults){

if ( $picasacontent =~ /<item>.*?<title>(.*?)<\/title><description>(.*?)<\/description><enclosure type='.*?' url='(.*?)' length='.*?'\/><link>(.*?)<\/link><media:group><media:content url='(.*?)' height='(.*?)' width='(.*?)' type='(.*?)' medium='(.*?)'\/><media:credit>(.*?)<\/media:credit>(.*?)<media:keywords.*?<media:thumbnail url='(.*?)' height='(.*?)' width='(.*?)'.*?<media:title type='plain'>(.*?)<\/media:title><\/media:group>/g ) {
	$pic_title = $1;
	$pic_description = $2;
	$pic_enclosure_url = $3;
	$pic_link = $4;
	$pic_media_content_url = $5;
	$pic_media_content_height = $6;
	$pic_media_content_width = $7;
	$pic_media_content_type = $8;
	$pic_media_content_medium = $9;
	$pic_media_credit = $10;
	$pic_media_description = $11;
	$pic_media_thumbnail_url = $12;
	$pic_media_thumbnail_height = $13;
	$pic_media_thumbnail_width = $14;
	$pic_media_title = $15;
}

if ( $pic_media_description =~ /<media:description type='.*?'>(.*?)</g ) {
	$pic_media_description = qq~<li><i>$gallery{'22'}</i><br />$1</li>~;
}

FromHTML($pic_description);

if ( $pic_description =~ /<table><tr><td style=".*?"><a href=".*?"><img style=".*?" src=".*?" alt=".*?"\/><\/a><\/td><td valign=".*?"><font color=".*?">.*?<\/font><font color=".*?">(.*?)<\/font><br\/><font color=\\".*?\\">.*?<\/font><font color=\\".*?\\">(.*?)<\/font><br\/><p><a href=".*?"><font color=".*?">.*?<\/font><\/a><\/p><\/td><\/tr><\/table>/g ) {
	$date_upload = $1;
	$number_comment = $2;
}

$picid = rindex($pic_link,"/") + 1;
$picid1 = substr($pic_link,$picid);
( $picidex, $pic_id ) = split /\#/xsm, $picid1;

        $quicklinks = qq~<div class="left" style="position:relative;$pic_display">
            <ul id="$pic_id" class="QuickLinks" onmouseover="keepLinks('$pic_id')" onmouseout="TimeClose('$pic_id')">
                <li><b>$pic_title</b></li>
                <li>$gallery{'25'} $number_comment</li>
                <li>$gallery{'5'} $date_upload</li>
                <li>$gallery{'26'} $pic_id</li>
                <li>$gallery{'7'} $pic_media_credit</li>
		<li><a href="$pic_media_content_url" data-rel="gb_image[nice_pics]" title="$pic_title" >$gallery{'18'}</a></li>
		$pic_media_description
        </ul><a href="javascript:quickLinks('$pic_id')">$infoimg</a></div>~;


	$picasacalls .= qq~
		<div class="center" style="display: inline-block;">
		<a href="$pic_media_content_url" data-rel="gb_imageset[nice_pics]" title="$pic_title" ><img class="hardShadeimg" src="$pic_media_thumbnail_url" border="0" /></a>
		<br />
		<div class="small right" id="hardShade" style="display: inline-block; width: $thumb_box_width; margin: 5px; padding: 10px; margin-bottom:50px">
		    <a href="$pic_media_content_url" data-rel="gb_imageset[nice_picsa]" title="$pic_title" >$photoindeximg</a>

	~;
if ( $linkpicasaindex ) {
	$picasacalls .= qq~
		    <a href="$pic_media_content_url" target="_blank" title="$gallery{'18'} '$pic_title' $gallery{'24'}" title="$pic_title" >$photolinkimg</a>
	~;
}
	$picasacalls .= qq~
		$quicklinks
                    <span style="float: left;">
                        <b># $albumzahl</b>
                    </span>
		</div>
		</div>
	~;

	$albumzahl++;
	$i++;
}

	$yymain .= qq~
	<table class="tabtitle pad_3px">
		<tr>
		 <td>$pic_gallery $gallery{'23'} $useralbumtitle ($picasResults)</td>
		</tr>
	</table>
	<table class="bordercolor pad_4px cs_thin" >
	~;
if ($media_description) {
	$yymain .= qq~
		<tr>
		 <td class="windowbg left">
			$media_description
		 </td>
		</tr>
	~;
}
	$yymain .= qq~
		<tr>
		 <td class="windowbg2 left">
			$picasacalls
		 </td>
		</tr>
		<tr>
        	 <td class="catbg left" style="padding: 8px;">
	<script>
	    function picuploadwin() {
	        window.open("https://docs.google.com/picker?protocol=gadgets&relayUrl=https://picasaweb.google.com/s/v/84.17/rpc_relay.html&hostId=pwa&hl=$piclangcode&rpcService=lhid_picker&rpctoken=1g73kb46x4u9q&selectButtonLabel=Ok&navHidden=true&multiselectEnabled=true&white=true&chromeMode=none&nav=((%22upload%22,null,%7B%22cRename%22:%22pname%22,%22query%22:%22photos%22,%22data%22:%7B%22owner_name%22:%22$picasaid%22,%22disable_asbe_notification%22:%22false%22,%22streamid%22:null%7D%7D))", 'list', 'width=800,height=500, scrollbars=yes');
	    }
	</script>
	<a href="javascript:picuploadwin()">$gallery{'15'}</a> <a href="$scripturl?picasaid=$picasaid">$gallery{'16'}</a>
                 </td>
		</tr>
	</table>		 
	~;

	template();
	exit;
}

#<----------------------------------------------->#
# Plugin Section
#<----------------------------------------------->#

sub GalleryPlugin {

$useralbum = $FORM{'album'};
$picasaid = $FORM{'picasaid'} || $INFO{'picasaid'};
$useralbumtitle = $FORM{'album_ti'};
$pics_in_album = $FORM{'photos'};
$media_description = $FORM{'media_description'};

if ( $useralbum eq q{} ) {
	$yySetLocation = qq~$scripturl?action=gallery~;
    redirectexit();
}

        my $pic_display = 'display:inline';
        if ( $ENV{'HTTP_USER_AGENT'} =~ /opera/ism ) {
            $pic_display = 'display:inline-block';
        }
        elsif ( $ENV{'HTTP_USER_AGENT'} =~ /firefox/ism ) {
            $pic_display = 'display:inline-block';
        }

#<----------------------------------------------->#
# Plugin Div Viewer
#<----------------------------------------------->#

if ($FORM{'plugin'} eq "divviewer") {

$thumb_box_width = "". ($thumb_divviewer_size + 10) ."px";

$yyinlinestyle .= qq~
<script src="$yyhtml_root/PicasaGallery/plugins/divviewer/DV.js" type="text/javascript" charset="ISO-8859-1"></script>
~;

$dvviewer_js = qq~
<script language="JavaScript" type="text/javascript">
	<!--
var myPics = new Array();
~;

my $feedurl = "https://picasaweb.google.com/data/feed/base/user/$picasaid/albumid/$useralbum?alt=rss&start-index=1&max-results=1000&hl=$piclangcode&kind=photo&imgmax=1600&thumbsize=$thumb_divviewer_size$thumb_divviewer_c_u";
my $picasacontent = get($feedurl);

	@totalResults = $picasacontent =~ /<openSearch:totalResults>(.*?)<\/openSearch:totalResults>/g;

$res=0;
while ($res<(1*2)){
	$picasResults = qq~$totalResults[$res]~;
	$res+=2;
}
$dvviewer=0;
$i=0;
$albumzahl=1;
$gal_pic_row=1;
while ($i < $picasResults){

if ( $picasacontent =~ /<item>.*?<title>(.*?)<\/title><description>(.*?)<\/description><enclosure type='.*?' url='(.*?)' length='.*?'\/><link>(.*?)<\/link><media:group><media:content url='(.*?)' height='(.*?)' width='(.*?)' type='(.*?)' medium='(.*?)'\/><media:credit>(.*?)<\/media:credit>(.*?)<media:keywords.*?<media:thumbnail url='(.*?)' height='(.*?)' width='(.*?)'.*?<media:title type='plain'>(.*?)<\/media:title><\/media:group>/g ) {
	$pic_title = $1;
	$pic_description = $2;
	$pic_enclosure_url = $3;
	$pic_link = $4;
	$pic_media_content_url = $5;
	$pic_media_content_height = $6;
	$pic_media_content_width = $7;
	$pic_media_content_type = $8;
	$pic_media_content_medium = $9;
	$pic_media_credit = $10;
	$pic_media_description = $11;
	$pic_media_thumbnail_url = $12;
	$pic_media_thumbnail_height = $13;
	$pic_media_thumbnail_width = $14;
	$pic_media_title = $15;
}

if ( $pic_media_description =~ /<media:description type='.*?'>(.*?)</g ) {
	$pic_media_description = qq~<li><i>$gallery{'22'}</i><br />$1</li>~;
}

FromHTML($pic_description);

if ( $pic_description =~ /<table><tr><td style=".*?"><a href=".*?"><img style=".*?" src=".*?" alt=".*?"\/><\/a><\/td><td valign=".*?"><font color=".*?">.*?<\/font><font color=".*?">(.*?)<\/font><br\/><font color=\\".*?\\">.*?<\/font><font color=\\".*?\\">(.*?)<\/font><br\/><p><a href=".*?"><font color=".*?">.*?<\/font><\/a><\/p><\/td><\/tr><\/table>/g ) {
	$date_upload = $1;
	$number_comment = $2;
}

$picid = rindex($pic_link,"/") + 1;
$picid1 = substr($pic_link,$picid);
( $picidex, $pic_id ) = split /\#/xsm, $picid1;

	$dvviewer_js .= qq~
		myPics[$albumzahl] = '<img src="$pic_media_content_url" width="$pic_media_content_width" height="$pic_media_content_height" border="0" alt="Slide $albumzahl of $picasResults">';
	~;

        $quicklinks = qq~<div class="left" style="position:relative;$pic_display">
            <ul id="$pic_id" class="QuickLinks" onmouseover="keepLinks('$pic_id')" onmouseout="TimeClose('$pic_id')">
                <li><b>$pic_title</b></li>
                <li>Comments: $number_comment</li>
                <li>Date: $date_upload</li>
                <li>Photo ID: $pic_id</li>
                <li>Credit: $pic_media_credit</li>
		<li><a href="#" onClick="DvViewer($albumzahl);return false;" title="$gallery{'18'}: '$pic_title' $gallery{'12'}">$gallery{'18'}</a></li>
		$pic_media_description
        </ul><a href="javascript:quickLinks('$pic_id')">$infoimg</a></div>~;


	$picasacalls .= qq~
		<div class="small left" id="hardShade" style="display: inline-block; width: $thumb_box_width; margin: 5px; padding: 10px;">
                    <b># $albumzahl</b><br /><br />
                    <center><a href="#" onClick="DvViewer($albumzahl);return false;"><img class="hardShadeimg" src="$pic_media_thumbnail_url" border="0" ></a></center><br /><br />
		    <a href="#" onClick="DvViewer($albumzahl);return false;" title="$gallery{'18'} '$pic_title' $gallery{'12'}">$photoindeximg</a> 
		$quicklinks
		</div>
	~;

	$albumzahl++;
	$dvviewer++;
	$i++;
}
	$dvviewer_js .= qq~
function DvViewer(thepic)
{
  //unset array to hide paging
  dv.setAllImagesArray(myPics);
  dv.showDV(myPics[thepic]);
}
	//-->
</script>
	~;

	$yymain .= qq~
	$dvviewer_js
	<table class="tabtitle pad_3px">
		<tr>
		 <td>$pic_gallery $gallery{'19'} $useralbumtitle ($picasResults)</td>
		</tr>
	</table>
	<table class="bordercolor pad_4px cs_thin" >
	~;
if ($media_description) {
	$yymain .= qq~
		<tr>
		 <td class="windowbg left">
			$media_description
		 </td>
		</tr>
	~;
}
	$yymain .= qq~
		<tr>
		 <td class="windowbg2 left">
			$picasacalls
		 </td>
		</tr>
		<tr>
        	 <td class="catbg left" style="padding: 8px;">
	<script>
	    function picuploadwin() {
	        window.open("https://docs.google.com/picker?protocol=gadgets&relayUrl=https://picasaweb.google.com/s/v/84.17/rpc_relay.html&hostId=pwa&hl=$piclangcode&rpcService=lhid_picker&rpctoken=1g73kb46x4u9q&selectButtonLabel=Ok&navHidden=true&multiselectEnabled=true&white=true&chromeMode=none&nav=((%22upload%22,null,%7B%22cRename%22:%22pname%22,%22query%22:%22photos%22,%22data%22:%7B%22owner_name%22:%22$picasaid%22,%22disable_asbe_notification%22:%22false%22,%22streamid%22:null%7D%7D))", 'list', 'width=800,height=500, scrollbars=yes');
	    }
	</script>
	<a href="javascript:picuploadwin()">$gallery{'15'}</a> <a href="$scripturl?picasaid=$picasaid">$gallery{'16'}</a>
                 </td>
		</tr>
	</table>		 
	~;
}

#<----------------------------------------------->#
# Plugin Galleria
#<----------------------------------------------->#

if ($FORM{'plugin'} eq "galleria") {

$galleria_box_width = $galleria_width ."px";
$galleria_box_height = $galleria_height ."px";



	$yyinlinestyle .= qq~
<script src="http://ajax.googleapis.com/ajax/libs/jquery/1/jquery.js"></script>
<script type="text/javascript" src="$yyhtml_root/PicasaGallery/plugins/galleria/galleria-1.3.5.min.js"></script>
<script type="text/javascript" src="$yyhtml_root/PicasaGallery/plugins/galleria/picasa/galleria.picasa.min.js"></script>
        <style>
            /* This rule is read by Galleria to define the gallery height: */
            .galleria{width: $galleria_box_width; height:$galleria_box_height;} 
        </style>
~;

	$yymain .= qq~
	<table class="tabtitle pad_3px">
		<tr>
		 <td>$pic_gallery $gallery{'20'} $useralbumtitle ($pics_in_album)</td>
		</tr>
	</table>
	<table class="bordercolor pad_4px cs_thin" >
	~;
if ($media_description) {
	$yymain .= qq~
		<tr>
		 <td class="windowbg left">
			$media_description
		 </td>
		</tr>
	~;
}
	$yymain .= qq~
		<tr>
		 <td class="windowbg2 left">
			<center><div class="galleria"></div></center>
	<script>
	    function picuploadwin() {
	        window.open("https://docs.google.com/picker?protocol=gadgets&relayUrl=https://picasaweb.google.com/s/v/84.17/rpc_relay.html&hostId=pwa&hl=$piclangcode&rpcService=lhid_picker&rpctoken=1g73kb46x4u9q&selectButtonLabel=Ok&navHidden=true&multiselectEnabled=true&white=true&chromeMode=none&nav=((%22upload%22,null,%7B%22cRename%22:%22pname%22,%22query%22:%22photos%22,%22data%22:%7B%22owner_name%22:%22$picasaid%22,%22disable_asbe_notification%22:%22false%22,%22streamid%22:null%7D%7D))", 'list', 'width=800,height=500, scrollbars=yes');
	    }
	    // Load the classic theme
	    Galleria.loadTheme('$yyhtml_root/PicasaGallery/plugins/galleria/themes/$galleria_theme/galleria.$galleria_theme.min.js');

	    Galleria.run('.galleria', {
	        // The user & album. This example fetches the album "Demo" from the user "galleriajs"
	        picasa: 'useralbum:$picasaid/$useralbum'
	    });
	    Galleria.configure({
	        lightbox: true
	    });
	</script>
		 </td>
		</tr>
		<tr>
		<tr>
        	 <td class="catbg left" style="padding: 8px;">
			<a href="javascript:picuploadwin()">$gallery{'15'}</a> <a href="$scripturl?picasaid=$picasaid">$gallery{'16'}</a>
                 </td>
		</tr>
	</table>
	~;
}

#<----------------------------------------------->#
# Plugin Picasa Flash Slider
#<----------------------------------------------->#

if ($FORM{'plugin'} eq "flash") {

if    ( $picasa_flash_width == 0 ) 	{ 
	$picasa_flash_w  = 144; $picasa_flash_h  = 96;	}
elsif ( $picasa_flash_width == 1 ) 	{ 
	$picasa_flash_w  = 288; $picasa_flash_h  = 192;	}
elsif ( $picasa_flash_width == 2 ) 	{ 
	$picasa_flash_w  = 400; $picasa_flash_h  = 267;	}
elsif ( $picasa_flash_width == 3 ) 	{ 
	$picasa_flash_w  = 600; $picasa_flash_h  = 400;	}
else  { $picasa_flash_w  = 800;
	$picasa_flash_h  = 533;	}

$picasa_flash_color =~ s/#//gsm;
$picasa_fix = ( ( $pics_in_album * 3000 ) + 1300 );

	$yyinlinestyle .= qq~
<script type="text/javascript" src="$yyhtml_root/PicasaGallery/plugins/flash/slideRun.js"></script>
~;

	$yymain .= qq~
	<table class="tabtitle pad_3px">
		<tr>
		 <td>$pic_gallery $gallery{'21'} $useralbumtitle ($pics_in_album)</td>
		</tr>
	</table>
	<table class="bordercolor pad_4px cs_thin" >
	~;
if ($media_description) {
	$yymain .= qq~
		<tr>
		 <td class="windowbg left">
			$media_description
		 </td>
		</tr>
	~;
}

	$yymain .= qq~
		<tr>
		 <td class="windowbg2 center">
			<center><embed type="application/x-shockwave-flash" src="https://picasaweb.google.com/s/c/bin/slideshow.swf" width="$picasa_flash_w" height="$picasa_flash_h" flashvars="host=picasaweb.google.com&hl=$piclangcode&feat=flashalbum&RGB=0x$picasa_flash_color&feed=https%3A%2F%2Fpicasaweb.google.com%2Fdata%2Ffeed%2Fapi%2Fuser%2F$picasaid%2Falbumid%2F$useralbum%3Falt%3Drss%26kind%3Dphoto%26hl%3D$piclangcode" pluginspage="http://www.macromedia.com/go/getflashplayer"></embed><img onerror="slideRun(this,$picasa_fix)" src="..." /></center>
 		 </td>
		</tr>
		<tr>
        	 <td class="catbg left" style="padding: 8px;">
	<script>
	    function picuploadwin() {
	        window.open("https://docs.google.com/picker?protocol=gadgets&relayUrl=https://picasaweb.google.com/s/v/84.17/rpc_relay.html&hostId=pwa&hl=$piclangcode&rpcService=lhid_picker&rpctoken=1g73kb46x4u9q&selectButtonLabel=Ok&navHidden=true&multiselectEnabled=true&white=true&chromeMode=none&nav=((%22upload%22,null,%7B%22cRename%22:%22pname%22,%22query%22:%22photos%22,%22data%22:%7B%22owner_name%22:%22$picasaid%22,%22disable_asbe_notification%22:%22false%22,%22streamid%22:null%7D%7D))", 'list', 'width=800,height=500, scrollbars=yes');
	    }
	</script>
	<a href="javascript:picuploadwin()">$gallery{'15'}</a> <a href="$scripturl?picasaid=$picasaid">$gallery{'16'}</a>
                 </td>
		</tr>
	</table>
	~;
}

	template();
	exit;
}

#<----------------------------------------------->#
# The Happy End :)
#<----------------------------------------------->#

1;
